<template>
  <v-app>
    <v-layout justify-center style="margin-top:100px;">
      <v-flex xs10 md10 style="padding:60px;">
        <v-card class="mx-auto" elevation="1" style="height:auto;">
          <v-container>
            {{ data_directcredit }}<br />
            <v-layout justify-center>
              <!-- {{data_directcredit}} -->
              <v-data-table
                :headers="headers"
                :items="data_directcredit"
                class="elevation-1 table-style"
                hide-actions
              >
                <template v-slot:items="props">
                  <tr>
                    <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>
                    <div v-if="props.item.status_message == 'In process'">
                      <td class="text-xs-left">
                        <!-- <v-radio-group v-model="props.item.status_message"
                        >
                          <v-radio label="Completed" :value="'Success'"></v-radio>
                          <v-radio label="Rejected" :value="'Fail'"></v-radio>
                        </v-radio-group> -->

                        <v-btn-toggle v-model="props.item.status_message">
                          <v-btn :value="'Success'" class="btn-completed"
                            >Completed
                          </v-btn>
                          <v-btn :value="'Fail'" class="btn-rejected"
                            >Rejected
                          </v-btn>
                        </v-btn-toggle>
                      </td>
                    </div>
                    <div v-else>{{ props.item.status_message }}</div>
                    <!-- <td class="text-xs-left" v-else>
                      {{props.item.status_message}}
                    </td> -->
                    <!-- <td
                      class="text-xs-left"
                      v-if="props.item.status_message == 'Success'"
                    >
                    </td>
                    <td
                      class="text-xs-left"
                      v-if="props.item.status_message == 'Fail'"
                    >
                    </td> -->
                  </tr>
                </template>
              </v-data-table>
            </v-layout>
          </v-container>
        </v-card>
      </v-flex>
    </v-layout>

    <v-footer>
      <span style="padding-left: 30px;">© 2021 - ePayment Sandbox</span>
    </v-footer>
  </v-app>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      invoicedata: [],
      token: "",
      mobileView: false,
      headers: [
        { text: "หมายเลขรายการจ่ายเงิน", value: "order_id", sortable: false },
        { text: "สถานะ", value: "status_message", sortable: false }
      ],
      // data_directcredit: [],
      direct_credit_result: [],
      data_directcredit: [
        {
          order_id: "PV-204",
          status_message: "In process"
        },
        {
          order_id: "PV-205",
          // status_message: "In process"
          status_message: "Success"
        },
        {
          order_id: "PV-206",
          // status_message: "In process"
          status_message: "Fail"
        }
      ],
      datetime: new Date(),
      t: []
    };
  },
  methods: {
    // async getSandboxDirectCredit() {
    //   try {
    //     var { data } = await this.axios.post(
    //       `${process.env.VUE_APP_APIHOST}/sendbox/directcredit`,
    //       {
    //         data: this.datalist
    //       },
    //       {
    //         headers: { Authorization: this.token }
    //       }
    //     );
    //     this.data_directcredit = data.data;
    //     console.log(this.data_directcredit);
    //     // this.t = data.data
    //     // console.log("t: ", this.data_directcredit);
    //   } catch (error) {
    //     console.log(error.message);
    //   }
    // },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    callDirectCredit(_payment_no, _status) {
      // console.log("callDirectCredit", _payment_no);
      // console.log("callDirectCredit", _status);
      let _code = "";
      if (_status == "Success") {
        _code = "1";
      } else if (_status == "Fail") {
        _code = "2";
      }

      let _data = {
        transaction_ref: _payment_no,
        trasfer_status_code: _code,
        trasfer_status_message: _status,
        transaction_date: moment(this.datetime).format("YYYYMMDD"),
        transaction_time: moment(this.datetime).format("HHmmss")
      };

      this.direct_credit_result.push(_data);
      console.log("direct_credit_result", this.direct_credit_result);

      if (this.direct_credit_result.length == this.data_directcredit.length) {
        this.postDirectCreditCallback();
      }
    },
    async postDirectCreditCallback() {
      console.log("postDirectCreditCallback: ", this.data_directcredit);
      // alert('call api')

      // try {
      //   var { data } = await this.axios.post(
      //     `${process.env.VUE_APP_APIHOST}/directcredit/callback`,
      //     {
      //       direct_credit_result: this.direct_credit_result
      //     },
      //     {
      //       headers: { Authorization: this.token }
      //     }
      //   );
      // } catch (error) {
      //   console.log(error.message);
      // }
    }
  },
  watch: {
    data_directcredit: {
      handler(val, oldVal) {
        // console.log('book list changed')
        // console.log('book list changed: ', val[0].status_message)
        var a = 0;
        for (var i = 0; i < val.length; i++) {
          if (val[i].status_message != "In process") {
            a++;
          }
        }
        if (val.length == a) {
          // console.log('xxx');
          this.postDirectCreditCallback();
        }
      },
      deep: true
    }
    // data_directcredit(val){
    //   console.log('watch data_directcredit: ', val);
    //   // var a = 0
    //   // for (var i=0; i<val.length; i++) {
    //   //   if (val[i].status_message != "In process") {
    //   //     a++
    //   //   }
    //   // }
    //   // console.log("1: ", val[0].status_message);
    //   // console.log("a: ", a);
    //   // if (val.length == a) {
    //   //   console.log('xxx');
    //   //   this.postDirectCreditCallback();
    //   // }
    //   // return "111"
    // }
  },
  // computed: {},
  created() {
    this.handleView();
    var a = JSON.parse(this.$cookies.get("data"));
    console.log("cookie: ", a);
    console.log("cookie: 0", a[0]);
    // this.getSandboxDirectCredit();
  }
};
</script>

<style scoped>
.btn-completed {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #58a144;
  border-radius: 4px;
  text-transform: none;
  background-color: #ecf8ea !important;
}

.btn-rejected {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #d1392b;
  border-radius: 4px;
  text-transform: none;
  background-color: #fbe5e4 !important;
}
</style>
